<?xml version="1.0"?>

<tradingsystem>

<title>
	Williams %R System No.1
</title>

<description>
	&lt;b&gt;Name:&lt;br&gt;
	&lt;/b&gt;Williams %R System No.1&lt;b&gt;&lt;br&gt;
	Trading System Information:&lt;/b&gt;&lt;br&gt;
	The Williams %R was developed by Larry Williams. The Williams %R Oscillator is a momentum indicator which tells us if a Stock is &quot;overbought&quot; or &quot;oversold&quot;.
	&lt;a href="http://www.web-o-tron.com/school/tradingsystems/williamsr.php" target="webotron"&gt;External Informations&lt;/a&gt;&lt;br&gt;
	&lt;b&gt;Kind of System:&lt;/b&gt;&lt;br&gt;
	Mechanical Trading System&lt;br&gt;
</description>

<initialisation>

    global gArrayDate, gArrayOpen, gArrayHigh, gArrayLow, gArrayClose, gArrayVolume
    global gTradingResultArray, gchangeperiod
    global gSymbolName, gSymbolNameExpl, gTraSysInfos, gExplResults
    global gSignalCleaner, gCurrentTradingSystemName
    global gTradingSystemsArray, gReportGenerating, gAutSysNewCalc
    global gDataLenght, gLastDataLenght

	on new (me, theExtra)

	gTradingResultArray = []

	if gchangeperiod = "daily" then
    	theperiod = "d"
  	else if gchangeperiod = "weekly" then
    	theperiod = "w"
  	else if gchangeperiod = "intraday" then
    	theperiod = "d"
  	end if
	-- DEFAULT TRADING SYSTEM PREFERENCES
	systemArrays = getTradingSystemPrefs([[["Williams %R Value:",14],["Oversold Line:",30],["Overbought Line:",70]],[[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0],[0,0]]], theperiod)
	--
	-- RSI VALUE
	opt1 = systemArrays[1][1][2]
	-- OVERSOLD AREA
	opt2 = systemArrays[1][2][2]
	-- OVERBOUGHT AREA
	opt3 = systemArrays[1][3][2]
</initialisation>

<calculation>
	-- CALCULATES RSI ARRAY
	WILLIAMSRP = WILLIAMSRP(me, opt1)
	--
	repeat with counter = 1 to gArrayClose.count
    	--
    	-- START SYSTEM
    	--
    	if counter &gt; 1 then
    		-- RSI LEAVES OVERSOLD AREA
    		if WILLIAMSRP[counter] &gt;= opt2 and WILLIAMSRP[counter - 1] &lt;= opt2 then
    			add gTradingResultArray, 1
    		-- RSI LEAVES OVERBOUGHT AREA
    		else if WILLIAMSRP[counter] &lt;= opt3 and WILLIAMSRP[counter - 1] &gt;= opt3 then
    			add gTradingResultArray, 2
    		else
    			add gTradingResultArray, 0
    		end if
    	else
    		add gTradingResultArray, 0
    	end if
    	--
    	-- END SYSTEM
    	--
	end repeat
	--
	-- STOPS AND CLEANER
	gOldTradingResultArray = gTradingResultArray
	gTradingResultArray = STOPS(me, systemArrays[2], gTradingResultArray)
	if gSignalCleaner = 0 then
		gTradingResultArray = SIGNALCLEANER(me, gTradingResultArray, gOldTradingResultArray)
	end if
	
	-- BACKTEST PERIOD CHANGE IF NECCESSARY
	gTradingResultArray = changeBacktestPeriod(gTradingResultArray)
	
	--------------------------------------------
	-- TRADING SYSTEM INFORMATIONS
	--------------------------------------------
	gTraSysInfos = []
	add gTraSysInfos, value(["Williams %R Value:",opt1])
	add gTraSysInfos, value(["Oversold Line:",opt2])
	add gTraSysInfos, value(["Overbought Line:",opt3])
	if systemArrays[2][1][2] = 1 then
		add gTraSysInfos, value(["Stop Lose %:",systemArrays[2][1][1]])
	else
		add gTraSysInfos, value(["Stop Lose %:","--"])
	end if
	if systemArrays[2][2][2] = 1 then
		add gTraSysInfos, value(["Profit Exit %:",systemArrays[2][2][1]])
	else
		add gTraSysInfos, value(["Profit Exit %:","--"])
	end if
	if systemArrays[2][3][2] = 1 then
		add gTraSysInfos, value(["Bars Exit %:",systemArrays[2][3][1]])
	else
		add gTraSysInfos, value(["Bars Exit %:","--"])
	end if
	
theBackTest = systemBacktest (gTradingResultArray)
	member("backtestpercents").text = string(theBackTest[15]) &amp;&amp; "%"

	if gExplResults &lt;&gt; void then add gExplResults, systemBacktest (gTradingResultArray, gSymbolNameExpl)

	end
</calculation>

</tradingsystem>
